import React from 'react';
import classNames from 'classnames';

var Option = function Option(_ref, ref) {
  var item = _ref.item,
      prefixCls = _ref.prefixCls,
      className = _ref.className,
      _onClick = _ref.onClick;

  var parentName = function parentName(item) {
    return item.parents[item.parents.length - 1].name;
  };

  var mergedClassName = classNames(["".concat(prefixCls, "-list-option")], className);
  return React.createElement("li", {
    ref: ref,
    className: mergedClassName,
    key: item.code,
    onClick: function onClick() {
      return _onClick(item);
    }
  }, item.name, " ", item.level !== 1 && "(".concat(parentName(item), ")"));
};

var RefOption = React.forwardRef(Option);
RefOption.displayName = "Option";
export default RefOption;