import React, { Component } from 'react';
export interface FileInterface {
    id: string;
    name: string;
    originPath: string | null;
    path: string;
    thumbnailPath: string | null;
    type: string;
}
export interface UploadInfo {
    action: string;
    accept: string;
}
export interface UploadProps {
    width?: number;
    isView?: boolean;
    type?: 'card' | 'list';
    placeholder?: string;
    max?: number;
    uploadInfo: UploadInfo;
    onChange?: Function;
    value?: Array<FileInterface>;
    style?: React.CSSProperties;
    maxFileSize?: number;
    beforeUpload?: Function;
    showResult?: boolean;
    alwaysShowUploadButton?: boolean;
}
export interface UploadState {
    previewVisible: boolean;
    previewImage: FileInterface;
    previewType: string;
    fileUploading: boolean;
    fileList: Array<FileInterface>;
    width: number;
}
export default class Uploader extends Component<UploadProps, UploadState> {
    listType: {};
    constructor(props: UploadProps);
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: UploadProps): void;
    getValue: (value: any) => void;
    beforeUpload: (file: any) => any;
    handleCancel: () => void;
    handlePreview: (item: FileInterface) => import("antd/lib/message").MessageType | undefined;
    handleChange: (info: any) => void;
    handleRemoveFile: (file: FileInterface) => void;
    render(): JSX.Element;
}
