import React, { Component } from 'react';
import { TooltipProps } from 'antd/lib/tooltip';
import './style';
export declare type IEllipsisTooltipProps = TooltipProps & {
    title?: undefined;
    overlayStyle?: undefined;
};
export declare type IEllipsisTooltipInfo = {
    tooltip?: boolean | IEllipsisTooltipProps;
    overlayStyle: React.CSSProperties;
    title: React.ReactNode;
    children: any;
};
export interface IEllipsisProps {
    tooltip?: boolean | IEllipsisTooltipProps;
    length?: number;
    lines?: number;
    style?: React.CSSProperties;
    className?: string;
    fullWidthRecognition?: boolean;
}
export interface IEllipsisTextProps {
    tooltip?: boolean | IEllipsisTooltipProps;
    length: number;
    style?: React.CSSProperties;
    className?: string;
    fullWidthRecognition?: boolean;
    text: any;
}
export declare const getStrFullLength: (str?: string) => number;
export declare const cutStrByFullLength: (str: string | undefined, maxLength: number) => string;
export default class Ellipsis extends Component<IEllipsisProps, any> {
    root: HTMLDivElement;
    content: HTMLDivElement;
    node: HTMLDivElement;
    shadow: HTMLDivElement;
    shadowChildren: HTMLDivElement;
    constructor(props: IEllipsisProps);
    componentDidMount(): void;
    componentDidUpdate(perProps: IEllipsisProps): void;
    computeLine: () => void;
    bisection: (th: number, m: number, b: number, e: number, text: string, shadowNode: any) => number;
    handleRoot: (n: HTMLDivElement) => void;
    handleContent: (n: HTMLDivElement) => void;
    handleNode: (n: HTMLDivElement) => void;
    handleShadow: (n: HTMLDivElement) => void;
    handleShadowChildren: (n: HTMLDivElement) => void;
    render(): any;
}
