"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _antd = require("antd");

var _debounce = _interopRequireDefault(require("lodash/debounce"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var Option = _antd.Select.Option;

var ScrollSelect =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ScrollSelect, _React$Component);

  function ScrollSelect(props) {
    var _this;

    _classCallCheck(this, ScrollSelect);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ScrollSelect).call(this, props));
    _this.flag = true;

    _this.handleChange = function (val, option) {
      var onChange = _this.props.onChange;

      if (!val) {
        _this.handleSearch();
      }

      if (onChange) {
        onChange(val, option);
      }
    };

    _this.handleSearch = function () {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      var _this$props = _this.props,
          onSearch = _this$props.onSearch,
          _this$props$pageSize = _this$props.pageSize,
          pageSize = _this$props$pageSize === void 0 ? 10 : _this$props$pageSize;

      if (!_this.flag) {
        return;
      }

      _this.setState({
        data: [],
        fetching: true,
        mode: 'multiple'
      });

      if (onSearch) {
        onSearch({
          q: value,
          pageSize: pageSize
        }).then(function (res) {
          if (res.errorCode === 0) {
            _this.setState({
              data: res.data,
              pagination: res.pagination,
              searchVal: value,
              fetching: false,
              mode: ''
            });

            if (_this.refs.scrollSelect) {
              _this.refs.scrollSelect.rcSelect.onPopupFocus();
            }
          }
        });
      }
    };

    _this.handleBlur = function (options) {
      if (options.length == 0) {
        _this.handleSearch();
      }
    };

    _this.handleScroll = function (e) {
      var _this$props2 = _this.props,
          onSearch = _this$props2.onSearch,
          _this$props2$pageSize = _this$props2.pageSize,
          pageSize = _this$props2$pageSize === void 0 ? 10 : _this$props2$pageSize;
      var _e$target = e.target,
          scrollTop = _e$target.scrollTop,
          clientHeight = _e$target.clientHeight,
          scrollHeight = _e$target.scrollHeight;
      var _this$state = _this.state,
          searchVal = _this$state.searchVal,
          pagination = _this$state.pagination,
          data = _this$state.data;

      if (scrollTop + clientHeight == scrollHeight && data.length < pagination.totalResult) {
        if (onSearch) {
          onSearch({
            q: searchVal,
            pageIndex: pagination.currentPage + 1,
            pageSize: pageSize
          }).then(function (res) {
            if (res.errorCode === 0) {
              _this.setState({
                data: _toConsumableArray(data).concat(res.data),
                pagination: res.pagination
              });
            }
          });
        }
      }
    };

    _this.state = {
      data: [],
      pagination: {},
      searchVal: '',
      fetching: false,
      mode: ''
    };
    _this.handleSearch = (0, _debounce["default"])(_this.handleSearch, 500);
    return _this;
  }

  _createClass(ScrollSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      document.addEventListener('compositionstart', function (e) {
        _this2.flag = false;
        e.stopPropagation();
        e.preventDefault();
        return false;
      });
      document.addEventListener('compositionend', function (e) {
        _this2.flag = true;
        e.stopPropagation();
        e.preventDefault();
        return false;
      });
      this.handleSearch();
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _a = this.props,
          _a$optionKey = _a.optionKey,
          optionKey = _a$optionKey === void 0 ? 'code' : _a$optionKey,
          _a$optionLabel = _a.optionLabel,
          optionLabel = _a$optionLabel === void 0 ? 'name' : _a$optionLabel,
          _a$optionCode = _a.optionCode,
          optionCode = _a$optionCode === void 0 ? 'code' : _a$optionCode,
          _a$showKey = _a.showKey,
          showKey = _a$showKey === void 0 ? true : _a$showKey,
          renderOption = _a.renderOption,
          value = _a.value,
          restProps = __rest(_a, ["optionKey", "optionLabel", "optionCode", "showKey", "renderOption", "value"]);

      var _this$state2 = this.state,
          data = _this$state2.data,
          fetching = _this$state2.fetching,
          mode = _this$state2.mode;
      var options;

      if (value && value.key) {
        options = data.filter(function (item) {
          return item[optionKey] !== value.key;
        }).map(function (item) {
          return renderOption ? renderOption(item) : _react["default"].createElement(Option, _extends({
            key: item[optionKey],
            value: item[optionKey]
          }, item), "".concat(item[optionLabel]).concat(showKey ? "(".concat(item[optionCode], ")") : ''));
        });
        options = [_react["default"].createElement(Option, {
          value: value.key
        }, value.label)].concat(_toConsumableArray(options));
      } else {
        options = data.map(function (item) {
          return renderOption ? renderOption(item) : _react["default"].createElement(Option, _extends({
            key: item[optionKey],
            value: item[optionKey]
          }, item), "".concat(item[optionLabel]).concat(showKey ? "(".concat(item[optionCode], ")") : ''));
        });
      }

      return _react["default"].createElement(_antd.Select, _extends({
        ref: "scrollSelect",
        labelInValue: true,
        mode: mode,
        showSearch: true,
        filterOption: false,
        onSearch: this.handleSearch,
        onBlur: function onBlur() {
          return _this3.handleBlur(options);
        },
        notFoundContent: fetching ? _react["default"].createElement(_antd.Spin, {
          size: "small"
        }) : null,
        onPopupScroll: this.handleScroll,
        value: value
      }, restProps, {
        onChange: this.handleChange
      }), options);
    }
  }]);

  return ScrollSelect;
}(_react["default"].Component);

exports["default"] = ScrollSelect;
ScrollSelect.defaultProps = {
  optionKey: 'code',
  optionLabel: 'name',
  optionCode: 'code',
  showKey: false,
  pageSize: 10
};