import React from 'react';
import { DraggableData, ControlPosition } from 'react-draggable';
import './style';
export interface SlideVerifyProps {
    width?: number;
    size?: 'small' | 'middle';
    hintTxt?: string;
    passTxt?: string;
    onStart?: (e?: React.MouseEvent<HTMLElement>, draggableData?: DraggableData) => void;
    onDrag?: (e?: React.MouseEvent<HTMLElement>, draggableData?: DraggableData) => void;
    onStop?: (isVerify?: Boolean, e?: React.MouseEvent<HTMLElement>, draggableData?: DraggableData) => void;
    onMouseDown?: (e?: MouseEvent) => void;
}
export interface SlideVerifyState {
    disabled?: boolean;
    icon?: string;
    handlerStatus?: string;
    offset?: number;
    position?: ControlPosition;
    passTxtLeft?: number;
}
export default class SlideVerify extends React.Component<SlideVerifyProps, SlideVerifyState> {
    static defaultProps: SlideVerifyProps;
    state: SlideVerifyState;
    private slider;
    componentDidMount(): void;
    handleMouseDown: (e: MouseEvent) => void;
    handleStart: (e: React.MouseEvent<HTMLElement, MouseEvent>, draggableData: DraggableData) => void;
    handleStop: (e: React.MouseEvent<HTMLElement, MouseEvent>, draggableData: DraggableData) => void;
    handleDrag: (e: React.MouseEvent<HTMLElement, MouseEvent>, draggableData: DraggableData) => void;
    resetSlide: () => void;
    render(): JSX.Element;
}
