"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDraggable = _interopRequireDefault(require("react-draggable"));

var _classnames = _interopRequireDefault(require("classnames"));

require("./style");

var _antd = require("antd");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var SlideVerify =
/*#__PURE__*/
function (_React$Component) {
  _inherits(SlideVerify, _React$Component);

  function SlideVerify() {
    var _this;

    _classCallCheck(this, SlideVerify);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SlideVerify).apply(this, arguments));
    _this.state = {
      disabled: false,
      icon: 'double-right'
    };
    _this.slider = (0, _react.createRef)();

    _this.handleMouseDown = function (e) {
      var onMouseDown = _this.props.onMouseDown;
      if (onMouseDown) onMouseDown(e);
    };

    _this.handleStart = function (e, draggableData) {
      var onStart = _this.props.onStart;

      _this.setState({
        handlerStatus: 'dragging'
      });

      if (onStart) onStart(e, draggableData);
    };

    _this.handleStop = function (e, draggableData) {
      var onStop = _this.props.onStop;
      var offset = draggableData.x - draggableData.y + draggableData.node.offsetWidth;
      var isVerify = false;
      var sliderDom = _this.slider.current;

      if (sliderDom) {
        if (offset !== sliderDom.clientWidth) {
          _this.setState({
            icon: 'close',
            disabled: true,
            handlerStatus: 'error'
          });

          setTimeout(_this.resetSlide, 700);
        } else {
          _this.setState({
            icon: 'check',
            disabled: true,
            handlerStatus: 'done'
          });

          isVerify = true;
        }

        if (onStop) onStop(isVerify, e, draggableData);
      }
    };

    _this.handleDrag = function (e, draggableData) {
      var onDrag = _this.props.onDrag;
      var offset = draggableData.x - draggableData.y + draggableData.node.offsetWidth;

      _this.setState({
        offset: offset,
        position: {
          x: draggableData.x - draggableData.y,
          y: 0
        }
      });

      if (onDrag) onDrag(e, draggableData);
    };

    _this.resetSlide = function () {
      _this.setState({
        position: {
          x: 0,
          y: 0
        },
        offset: 0,
        handlerStatus: "",
        icon: 'double-right',
        disabled: false
      });
    };

    return _this;
  }

  _createClass(SlideVerify, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var sliderDom = this.slider.current;

      if (sliderDom) {
        this.setState({
          passTxtLeft: sliderDom.clientWidth / 2
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          size = _this$props.size,
          hintTxt = _this$props.hintTxt,
          passTxt = _this$props.passTxt,
          width = _this$props.width;
      var _this$state = this.state,
          position = _this$state.position,
          icon = _this$state.icon,
          disabled = _this$state.disabled,
          handlerStatus = _this$state.handlerStatus,
          offset = _this$state.offset,
          passTxtLeft = _this$state.passTxtLeft;
      var dragCls = handlerStatus ? "".concat(handlerStatus) : "";
      var handlerSty = {};

      if (handlerStatus == 'error') {
        handlerSty.transition = 'all .2s linear';
      }

      return _react["default"].createElement("div", {
        ref: this.slider,
        className: (0, _classnames["default"])('slideVerify', "is-".concat(size)),
        style: {
          width: width
        }
      }, _react["default"].createElement("div", {
        className: "progress ".concat(dragCls),
        style: {
          width: offset
        }
      }, _react["default"].createElement("span", {
        className: "passTxt",
        style: {
          left: passTxtLeft
        }
      }, passTxt)), _react["default"].createElement("span", {
        className: "hintTxt"
      }, hintTxt), _react["default"].createElement(_reactDraggable["default"], {
        axis: "x",
        bounds: "parent",
        disabled: disabled,
        onMouseDown: this.handleMouseDown,
        onStart: this.handleStart,
        onDrag: this.handleDrag,
        onStop: this.handleStop,
        position: position
      }, _react["default"].createElement("div", {
        ref: "handler",
        className: "slideHandler ".concat(dragCls),
        style: handlerSty
      }, _react["default"].createElement(_antd.Icon, {
        type: icon
      }))));
    }
  }]);

  return SlideVerify;
}(_react["default"].Component);

exports["default"] = SlideVerify;
SlideVerify.defaultProps = {
  width: 400,
  size: 'middle',
  hintTxt: '向右滑动验证',
  passTxt: '验证通过'
};