"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Option = function Option(_ref, ref) {
  var item = _ref.item,
      prefixCls = _ref.prefixCls,
      className = _ref.className,
      _onClick = _ref.onClick;

  var parentName = function parentName(item) {
    return item.parents[item.parents.length - 1].name;
  };

  var mergedClassName = (0, _classnames["default"])(["".concat(prefixCls, "-list-option")], className);
  return _react["default"].createElement("li", {
    ref: ref,
    className: mergedClassName,
    key: item.code,
    onClick: function onClick() {
      return _onClick(item);
    }
  }, item.name, " ", item.level !== 1 && "(".concat(parentName(item), ")"));
};

var RefOption = _react["default"].forwardRef(Option);

RefOption.displayName = "Option";
var _default = RefOption;
exports["default"] = _default;