"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _classnames = _interopRequireDefault(require("classnames"));

var _antd = require("antd");

var _OptionList = _interopRequireDefault(require("./OptionList"));

var _tools = require("../_util/tools");

var _KeyCode = _interopRequireDefault(require("rc-util/lib/KeyCode"));

require("./style");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var TabPane = _antd.Tabs.TabPane;

var TabCascader =
/*#__PURE__*/
function (_Component) {
  _inherits(TabCascader, _Component);

  function TabCascader(props) {
    var _this;

    _classCallCheck(this, TabCascader);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TabCascader).call(this, props));

    _this.renderValue = function (items) {
      var inputProps = _this.props.inputProps;

      if (!inputProps || !inputProps.renderValue) {
        return items.map(function (i) {
          return i.name;
        }).join('-');
      } else {
        return inputProps.renderValue(items);
      }
    };

    _this.initPagination = function () {
      var pagination = _this.props.pagination;

      if (pagination) {
        var initPagination = {
          currentPage: 1,
          currentResult: 0,
          pageSize: 10,
          totalPage: 0,
          totalResult: 0
        };

        if (typeof pagination == 'boolean') {
          _this.setState({
            pagination: initPagination
          });
        } else if (_typeof(pagination) == 'object') {
          _this.setState({
            pagination: _extends(initPagination, pagination)
          });
        }
      }
    };

    _this.setInitialValue = function (dataSource, value) {
      var groupCode = value[0].groupCode;
      var panelIdx = dataSource.findIndex(function (data) {
        return data.code == groupCode;
      });

      if (panelIdx == -1) {
        throw new Error("value does't in the top datas.");
      }

      var panelData = dataSource[panelIdx];
      var maxLevel = panelData.maxLevel;
      var lastItem = value[value.length - 1];

      if (panelData && panelData.items.length > 0) {
        for (var i = 0; i < panelData.items.length; i++) {
          var targetLevel = lastItem.level == maxLevel ? maxLevel : lastItem.level + 1;

          if (panelData.items[i].entry && panelData.items[i].level == targetLevel) {
            _this.setState({
              firstTab: panelIdx,
              secondTab: i
            });

            break;
          }
        }
      }
    };

    _this.handleOutsideClick = function (e) {
      var selectedItems = _this.state.selectedItems;
      var el = _this.el;
      e.stopPropagation();
      var target = e.target;

      if (!document.contains(target)) {
        return;
      }

      if (!el.contains(target)) {
        _this.setState({
          visible: false,
          searchVisible: false,
          inputVal: _this.renderValue(selectedItems)
        });
      }
    };

    _this.handleTopTabChange = function (tabKey) {
      var onTopTabChange = _this.props.onTopTabChange;
      var numKey = Number(tabKey);

      _this.setState({
        secondTab: 0,
        firstTab: numKey
      });

      if (onTopTabChange) {
        onTopTabChange(numKey);
      }
    };

    _this.handleSecondTabChange = function (tabKey) {
      var _this$props = _this.props,
          onTabChange = _this$props.onTabChange,
          dataSource = _this$props.dataSource;
      var _this$state = _this.state,
          firstTab = _this$state.firstTab,
          selectedItems = _this$state.selectedItems;
      var currentKey = Number(tabKey);
      var currentTabData = dataSource[firstTab].items[currentKey];

      if (currentTabData && currentTabData.items.length > 0) {
        _this.setState({
          secondTab: currentKey
        });
      } else {
        if (onTabChange) {
          _this.setState({
            tabLoading: true
          });

          var currentItem = selectedItems.find(function (item) {
            return item.level === currentTabData.level;
          });
          onTabChange(currentKey, firstTab, currentItem).then(function () {
            _this.setState({
              tabLoading: false
            });

            _this.setState({
              secondTab: currentKey
            });
          });
        }
      }
    };

    _this.handleClickItem = function (item) {
      var _this$props2 = _this.props,
          onChange = _this$props2.onChange,
          onItemClick = _this$props2.onItemClick,
          dataSource = _this$props2.dataSource;
      var _this$state2 = _this.state,
          selectedItems = _this$state2.selectedItems,
          firstTab = _this$state2.firstTab,
          secondTab = _this$state2.secondTab;

      if (selectedItems.length == 0) {
        selectedItems.push(item);
      } else {
        // 换组选择了
        if (selectedItems[0].groupCode !== item.groupCode) {
          selectedItems = [item];
        } else {
          var parentIdx = 0;
          var hasParent = selectedItems.some(function (sItem, sIdx) {
            if (sItem.code == item.parentCode) {
              parentIdx = sIdx;
            }

            return sItem.code == item.parentCode;
          });

          if (!hasParent) {
            selectedItems = [item];
          } else {
            selectedItems = selectedItems.slice(0, parentIdx + 1);
            selectedItems.push(item);
          }
        }
      }

      var displayVal = _this.renderValue(selectedItems);

      _this.setState({
        selectedItems: selectedItems,
        inputVal: displayVal
      });

      if (dataSource[firstTab].maxLevel == item.level) {
        _this.setState({
          visible: false
        });
      } // 异步加载下一级项数据


      if (onItemClick) {
        if (item.level !== dataSource[firstTab].maxLevel) {
          if (secondTab == 0 && firstTab == 0) {
            _this.setState({
              secondTab: secondTab + 2,
              tabLoading: true
            });
          } else {
            _this.setState({
              secondTab: secondTab + 1,
              tabLoading: true
            });
          }
        }

        onItemClick(secondTab, firstTab, item).then(function () {
          _this.setState({
            tabLoading: false
          });

          if (onChange) {
            onChange(selectedItems);
          }
        });
      } else {
        // 静态数据
        var nextTabData = dataSource[firstTab].items[secondTab + 1];

        if (nextTabData && nextTabData.items.length > 0) {
          _this.setState({
            secondTab: secondTab + 1
          });
        }
      }
    };

    _this.handleSearchItemClick = function (item) {
      return __awaiter(_assertThisInitialized(_this), void 0, void 0,
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee() {
        var _this2 = this;

        var _this$props3, dataSource, onSearchItemClick, onChange, _this$state3, firstTab, selectedItems, itemList, startLevel, displayVal;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this$props3 = this.props, dataSource = _this$props3.dataSource, onSearchItemClick = _this$props3.onSearchItemClick, onChange = _this$props3.onChange;
                _this$state3 = this.state, firstTab = _this$state3.firstTab, selectedItems = _this$state3.selectedItems;
                firstTab = Number(item.groupCode);
                selectedItems = [];
                itemList = [].concat(_toConsumableArray(item.parents ? item.parents : []), [item]);
                startLevel = firstTab == 0 ? 2 : 1;
                selectedItems = itemList.filter(function (nItem) {
                  return nItem.level >= startLevel;
                });
                displayVal = this.renderValue(selectedItems);
                this.setState({
                  firstTab: firstTab,
                  searchVisible: false,
                  visible: true,
                  selectedItems: selectedItems,
                  inputVal: displayVal
                });

                if (onChange) {
                  onChange(selectedItems);
                }

                if (item.level == dataSource[firstTab].maxLevel) {
                  this.setState({
                    visible: false
                  });
                } else {
                  if (onSearchItemClick) {
                    this.setState({
                      tabLoading: true
                    });
                    onSearchItemClick(item).then(function () {
                      _this2.setState({
                        tabLoading: false
                      });
                    });
                  }
                }

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
    };

    _this.hanldeInputChange = function (e) {
      var _this$props4 = _this.props,
          onClear = _this$props4.onClear,
          onChange = _this$props4.onChange;
      var inputVal = e.target.value;

      _this.setState({
        inputVal: inputVal
      });

      if (!inputVal) {
        _this.setState({
          visible: false,
          searchVisible: false
        }); // click the clear icon


        if (e.type == 'click') {
          _this.setState({
            selectedItems: [],
            firstTab: 0,
            secondTab: 0
          });

          if (onChange) {
            onChange([]);
          }

          if (onClear) {
            onClear(e);
          }
        }

        return;
      }

      _this.setState({
        isSearching: true,
        visible: false,
        searchVisible: true
      });

      _this.debounceSearch(inputVal);
    };

    _this.handleSearch = function (val) {
      var onSearch = _this.props.onSearch;
      var _this$state4 = _this.state,
          searchVisible = _this$state4.searchVisible,
          pagination = _this$state4.pagination;

      if (onSearch && searchVisible) {
        _this.setState({
          isSearching: true,
          visible: false,
          searchVisible: true
        });

        var query = {
          content: val
        };

        if (pagination) {
          query.pageSize = pagination.pageSize;
        }

        onSearch(query).then(function (res) {
          _this.setState({
            fetchList: res.data || [],
            pagination: res.pagination,
            isSearching: false
          });
        });
      }
    };

    _this.handleInputClick = function (e) {
      e.target.select();

      _this.setState({
        visible: true
      });
    };

    _this.handleInputBlur = function (e) {
      var searchVisible = _this.state.searchVisible;
      var onBlur = _this.props.onBlur;
      var el = _this.el;
      var target = e.target;

      _this.setState({
        searchVisible: false
      });

      if (searchVisible && !el.contains(target)) {
        _this.setState({
          selectedItems: [],
          inputVal: ''
        });
      }

      if (onBlur) {
        onBlur(e);
      }
    };

    _this.handleSearchScroll = function (e) {
      var _this$props5 = _this.props,
          onPopupScroll = _this$props5.onPopupScroll,
          onSearch = _this$props5.onSearch;
      var _this$state5 = _this.state,
          fetchList = _this$state5.fetchList,
          pagination = _this$state5.pagination,
          inputVal = _this$state5.inputVal;
      var target = e.target;
      var scrollTop = target.scrollTop,
          scrollHeight = target.scrollHeight,
          clientHeight = target.clientHeight;
      if (!pagination) return;

      if (onPopupScroll) {
        onPopupScroll(e);
      }

      if (scrollTop + clientHeight == scrollHeight && fetchList.length < pagination.totalResult) {
        if (onSearch) {
          onSearch({
            content: inputVal,
            pageIndex: pagination.currentPage + 1,
            pageSize: pagination.pageSize
          }).then(function (res) {
            if (res.errorCode === 0) {
              _this.setState({
                fetchList: _toConsumableArray(fetchList).concat(res.data),
                pagination: res.pagination
              });
            }
          });
        }
      }
    };

    _this.onToggleDropdown = function () {
      var flag = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      _this.setState({
        searchVisible: flag
      });
    };

    _this.handleKeyDown = function (e) {
      var selectedItems = _this.state.selectedItems;
      var which = e.which;

      if (which === _KeyCode["default"].ESC) {
        _this.onToggleDropdown();

        _this.setState({
          inputVal: _this.renderValue(selectedItems)
        });

        return;
      }

      if (which === _KeyCode["default"].UP || which === _KeyCode["default"].DOWN) {
        e.preventDefault();
      }

      if (_this.listRef.current) {
        _this.listRef.current.onKeyDown(e);
      }
    };

    _this.renderItems = function (tabItem) {
      var items = tabItem.items;
      var _this$props6 = _this.props,
          colSpan = _this$props6.colSpan,
          prefixCls = _this$props6.prefixCls;
      var selectedItems = _this.state.selectedItems;

      var hasSelectedItem = function hasSelectedItem(item) {
        return selectedItems.findIndex(function (sItem) {
          return item.code == sItem.code;
        }) > -1 && tabItem.entry;
      };

      var itemList = items.map(function (item) {
        return _react["default"].createElement(_antd.Col, {
          xs: 12,
          md: colSpan,
          key: item.code
        }, _react["default"].createElement("li", {
          className: (0, _classnames["default"])({
            'tab-item-selected': hasSelectedItem(item)
          }),
          onClick: function onClick() {
            return _this.handleClickItem(item);
          }
        }, _react["default"].createElement("a", null, item.name)));
      });
      return _react["default"].createElement("div", {
        className: "".concat(prefixCls, "-tab-items")
      }, _react["default"].createElement("ul", {
        className: "".concat(prefixCls, "-panel-list")
      }, _react["default"].createElement(_antd.Row, null, items.length === 0 ? _react["default"].createElement(_antd.Empty, {
        className: "empty"
      }) : itemList)));
    };

    _this.renderContent = function () {
      var _this$props7 = _this.props,
          prefixCls = _this$props7.prefixCls,
          dataSource = _this$props7.dataSource,
          hint = _this$props7.hint,
          contentCls = _this$props7.contentCls,
          contentStyle = _this$props7.contentStyle;
      var _this$state6 = _this.state,
          visible = _this$state6.visible,
          firstTab = _this$state6.firstTab,
          secondTab = _this$state6.secondTab,
          tabLoading = _this$state6.tabLoading;
      var contentClassName = (0, _classnames["default"])("".concat(prefixCls, "-content-wrap"), contentCls, {
        'antd-pro-hidden': !visible
      });
      return _react["default"].createElement("div", {
        className: contentClassName,
        style: contentStyle
      }, _react["default"].createElement("div", {
        className: "hint"
      }, hint), _react["default"].createElement(_antd.Tabs, {
        animated: false,
        className: "".concat(prefixCls, "-top-tab"),
        activeKey: "".concat(firstTab),
        onChange: _this.handleTopTabChange
      }, dataSource.map(function (item, panelIdx) {
        return _react["default"].createElement(TabPane, {
          key: "".concat(panelIdx),
          tab: item.title
        }, _react["default"].createElement(_antd.Tabs, {
          animated: false,
          className: "".concat(prefixCls, "-second-tab"),
          activeKey: "".concat(secondTab),
          onChange: _this.handleSecondTabChange
        }, item.items.map(function (tabItem, tabIdx) {
          return _react["default"].createElement(TabPane, {
            key: "".concat(tabIdx),
            className: "".concat(prefixCls, "-tab-panel"),
            tab: _react["default"].createElement("li", {
              className: (0, _classnames["default"])({
                'tab-header-dot': tabItem.entry
              })
            }, tabItem.title)
          }, tabLoading && tabIdx === secondTab ? _react["default"].createElement("div", {
            className: "tab-loading"
          }, _react["default"].createElement(_antd.Spin, null)) : _this.renderItems(tabItem));
        })));
      })));
    };

    _this.state = {
      firstTab: 0,
      secondTab: 0,
      inputVal: '',
      selectedItems: [],
      visible: false,
      searchVisible: false,
      tabLoading: false,
      isSearching: false,
      fetchList: []
    };
    _this.debounceSearch = (0, _debounce["default"])(_this.handleSearch, 600);
    _this.listRef = _react["default"].createRef();
    return _this;
  }

  _createClass(TabCascader, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      document.addEventListener('click', this.handleOutsideClick, false);
      this.initPagination();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.removeEventListener('click', this.handleOutsideClick, false);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var _this$props8 = this.props,
          value = _this$props8.value,
          dataSource = _this$props8.dataSource;
      var dataSourceCondition = nextProps.dataSource && nextProps.dataSource.length > 0;
      var hasValChange = !(0, _tools.isArrayEqual)(nextProps.value, value);
      var hasDataSourceChange = !(0, _tools.isArrayEqual)(nextProps.dataSource, dataSource);

      if (nextProps.value && !_lodash["default"].isEmpty(nextProps.value) && dataSourceCondition && (hasValChange || hasDataSourceChange)) {
        this.setState({
          selectedItems: nextProps.value,
          inputVal: this.renderValue(nextProps.value)
        });
        this.setInitialValue(nextProps.dataSource, nextProps.value);
      }

      if (!nextProps.value && value && nextProps.dataSource && nextProps.dataSource.length > 0) {
        this.setState({
          selectedItems: [],
          inputVal: '',
          firstTab: 0,
          secondTab: 0
        });
      }
    }
  }, {
    key: "renderSearchSection",
    value: function renderSearchSection() {
      var _this$props9 = this.props,
          contentCls = _this$props9.contentCls,
          contentStyle = _this$props9.contentStyle,
          prefixCls = _this$props9.prefixCls,
          _this$props9$listHeig = _this$props9.listHeight,
          listHeight = _this$props9$listHeig === void 0 ? 200 : _this$props9$listHeig,
          _this$props9$listItem = _this$props9.listItemHeight,
          listItemHeight = _this$props9$listItem === void 0 ? 40 : _this$props9$listItem;
      var _this$state7 = this.state,
          fetchList = _this$state7.fetchList,
          isSearching = _this$state7.isSearching,
          searchVisible = _this$state7.searchVisible;
      var cls = (0, _classnames["default"])('search-section', contentCls, {
        'antd-pro-hidden': !searchVisible
      });
      return _react["default"].createElement("div", {
        className: cls,
        style: contentStyle,
        onScroll: this.handleSearchScroll
      }, isSearching ? _react["default"].createElement(_antd.Spin, {
        className: "loading-spin"
      }) : _react["default"].createElement(_OptionList["default"], {
        itemKey: "code",
        prefixCls: prefixCls,
        ref: this.listRef,
        height: listHeight,
        itemHeight: listItemHeight,
        data: fetchList,
        onSelect: this.handleSearchItemClick,
        notFoundContent: _react["default"].createElement(_antd.Empty, {
          className: "empty"
        })
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var inputVal = this.state.inputVal;
      var _this$props10 = this.props,
          className = _this$props10.className,
          style = _this$props10.style,
          inputProps = _this$props10.inputProps,
          prefixCls = _this$props10.prefixCls;
      var cascaderCls = (0, _classnames["default"])(prefixCls, className);
      var inputClassName = (0, _classnames["default"])("".concat(prefixCls, "-search-bar"), inputProps ? inputProps.className : '', _defineProperty({}, "".concat(prefixCls, "-search-suffix"), inputProps && inputProps.allowClear && inputProps.addonAfter));
      return _react["default"].createElement("div", {
        ref: function ref(node) {
          return _this3.el = node;
        },
        className: cascaderCls,
        style: style
      }, _react["default"].createElement(_antd.Input, _extends({}, _lodash["default"].omit(inputProps, ['renderValue']), {
        className: inputClassName,
        value: inputVal,
        onChange: this.hanldeInputChange,
        onKeyDown: this.handleKeyDown,
        onClick: this.handleInputClick,
        onBlur: this.handleInputBlur
      })), this.renderContent(), this.renderSearchSection());
    }
  }]);

  return TabCascader;
}(_react.Component);

exports["default"] = TabCascader;
TabCascader.defaultProps = {
  prefixCls: 'ant-tab-cascader',
  colSpan: 6
};