"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _antd = require("antd");

var _Ellipsis = _interopRequireDefault(require("../Ellipsis"));

require("./style");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var File = function File(props) {
  var item = props.item,
      handlePreview = props.handlePreview,
      _props$isUploading = props.isUploading,
      isUploading = _props$isUploading === void 0 ? true : _props$isUploading,
      handleRemove = props.handleRemove,
      width = props.width;
  var imgType = ['png', 'jpeg', 'jpg', 'pdf'];
  var fileType = item.name.split('.').reverse()[0].toLowerCase();
  var isImg = imgType.includes(fileType);
  var length = Math.floor((width - 100) / 14);
  return _react["default"].createElement("span", {
    className: 'uploadFile',
    onClick: function onClick() {
      return handlePreview(item);
    }
  }, _react["default"].createElement("div", {
    className: "ant-upload-list ant-upload-list-text"
  }, _react["default"].createElement("div", {
    className: "ant-upload-list-item ant-upload-list-item-done"
  }, _react["default"].createElement("div", {
    className: "ant-upload-list-item-info"
  }, _react["default"].createElement("span", {
    className: 'name'
  }, _react["default"].createElement(_antd.Icon, {
    style: {
      fontSize: 14
    },
    type: isImg ? 'file-image' : 'file'
  }), _react["default"].createElement("a", {
    className: 'name',
    style: {
      marginLeft: 20
    }
  }, _react["default"].createElement(_Ellipsis["default"], {
    tooltip: true,
    length: length
  }, item.name)))), isUploading ? _react["default"].createElement(_antd.Icon, {
    style: {
      fontSize: 14
    },
    type: "close",
    onClick: function onClick(e) {
      e.stopPropagation();
      handleRemove(item);
    }
  }) : _react["default"].createElement("div", null))));
};

var _default = File;
exports["default"] = _default;