"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _antd = require("antd");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Image = function Image(props) {
  var item = props.item,
      handlePreview = props.handlePreview,
      _props$isUploading = props.isUploading,
      isUploading = _props$isUploading === void 0 ? true : _props$isUploading,
      handleRemove = props.handleRemove;
  var imgType = ['png', 'jpeg', 'jpg', 'pdf'];
  var fileType = item.name.split('.').reverse()[0].toLowerCase();
  var canPrev = imgType.includes(fileType);
  return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("div", {
    className: "ant-upload-list ant-upload-list-picture-card",
    onClick: function onClick() {
      return handlePreview(item);
    }
  }, _react["default"].createElement("div", {
    className: "ant-upload-list-item ant-upload-list-item-done",
    style: {
      width: 102,
      height: 102
    }
  }, _react["default"].createElement("div", {
    className: "ant-upload-list-item-info"
  }, _react["default"].createElement("span", {
    style: {
      height: '100%',
      textAlign: 'center'
    }
  }, canPrev ? _react["default"].createElement("a", {
    className: "ant-upload-list-item-thumbnail",
    style: {
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center'
    }
  }, fileType !== 'pdf' ? _react["default"].createElement("img", {
    src: item.path,
    alt: item.name || ''
  }) : _react["default"].createElement("iframe", {
    src: item.path,
    title: item.name
  })) : _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_antd.Icon, {
    type: "picture",
    style: {
      fontSize: 26,
      lineHeight: 2,
      color: '#1890FF'
    }
  }), _react["default"].createElement("span", {
    className: "ant-upload-list-item-name"
  }, item.name)))), _react["default"].createElement("span", {
    className: "ant-upload-list-item-actions"
  }, _react["default"].createElement(_antd.Icon, {
    type: "eye",
    style: {
      cursor: 'pointer',
      color: '#fff',
      opacity: canPrev ? 1 : 0.4
    }
  }), isUploading ? _react["default"].createElement(_antd.Icon, {
    type: 'delete',
    style: {
      color: 'rgba(255, 255, 255, 0.85)',
      marginLeft: 10
    },
    onClick: function onClick(e) {
      e.stopPropagation();
      handleRemove(item);
    }
  }) : _react["default"].createElement("div", null)))));
};

var _default = Image;
exports["default"] = _default;